/****************************************************************************
** Form interface generated from reading ui file 'controlpanel.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef CONTROLPANEL_H
#define CONTROLPANEL_H

#include <qvariant.h>
#include <qmainwindow.h>
#include "qdatetime.h"
#include "qstatusbar.h"
#include "qvalidator.h"
#include "qfiledialog.h"
#include "qerrormessage.h"
#include "aboutdialog.h"
#include "helpdocumentationdialog.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QAction;
class QActionGroup;
class QToolBar;
class QPopupMenu;
class QGroupBox;
class QDateTimeEdit;
class QSpinBox;
class QToolButton;
class QFrame;
class QSlider;
class QLabel;
class QLineEdit;
class QTimeEdit;

class ControlPanel : public QMainWindow
{
    Q_OBJECT

public:
    ControlPanel( QWidget* parent = 0, const char* name = 0, WFlags fl = WType_TopLevel );
    ~ControlPanel();

    QGroupBox* replayPositionGroupBox;
    QDateTimeEdit* replayDateTimeEdit;
    QSpinBox* millisecondsSpinBox;
    QToolButton* applyReplayPostionToolButton;
    QFrame* line1_2_2;
    QSlider* replayPositionSlider;
    QGroupBox* ReplaySpeedGroupBox;
    QToolButton* playPauseToolButton;
    QFrame* line1;
    QLabel* timeScaleTextLabel;
    QLineEdit* timeScaleLineEdit;
    QLabel* timeScaleXTextLabel;
    QSlider* timeScaleSlider;
    QGroupBox* recordGroupBox;
    QToolButton* recordToolButton;
    QToolButton* videoClipToolButton;
    QToolButton* stillPicToolButton;
    QGroupBox* HistoricViewGroupBox;
    QLabel* timeWindowTextLabel;
    QSpinBox* timeWindowDaySpinBox;
    QTimeEdit* timeWindowTimeEdit;
    QSpinBox* timeWindowMillisecSpinBox;
    QToolButton* ApplyTimeWindowToolButton;
    QFrame* line1_2;
    QSlider* timeWindowSlider;
    QGroupBox* FilterGroupBox;
    QLabel* filterExpressionTextLabel;
    QLineEdit* filterLineEdit;
    QToolButton* applyFilterToolButton;
    QMenuBar *MenuBar;
    QPopupMenu *fileMenu;
    QPopupMenu *Mode;
    QPopupMenu *Replay;
    QPopupMenu *Record;
    QPopupMenu *View_2;
    QPopupMenu *helpMenu;
    QAction* fileNewAction;
    QAction* fileOpenAction;
    QAction* fileSaveAction;
    QAction* fileSaveAsAction;
    QAction* fileExitAction;
    QAction* helpContentsAction;
    QAction* helpIndexAction;
    QAction* helpAboutAction;
    QActionGroup* replayActionGroup;
    QAction* playAction;
    QAction* pauseAction;
    QActionGroup* modeActionGroup;
    QAction* monitorLocalHostAction;
    QAction* replayCaptureFileAction;
    QAction* viewDisplayWindowAction;
    QAction* viewPlotterSettingsAction;
    QAction* replayAction;
    QAction* replayReplay_RateAction;
    QAction* replayTime_WindowAction;
    QAction* replayReplay_Rate1_Millisecond_per_Second_0001xAction;
    QAction* replayReplay_RateNormal_Playback_Speed_1xAction;
    QAction* replayReplay_Rate1_Minute_per_Second_60xAction;
    QAction* replayReplay_Rate1_Hour_per_Second_3600xAction;
    QAction* replayReplay_Rate1_Day_per_Second_86000xAction;
    QAction* replayTime_Window1_SecondAction;
    QAction* replayTime_Window1_MinuteAction;
    QAction* replayTime_Window1_HourAction;
    QAction* replayTime_Window1_DayAction;
    QAction* replayTime_Window1_Week_7_DaysAction;
    QAction* replayTime_Window1_Month_31_DaysAction;
    QAction* replayTime_Window1_Year_365_DaysAction;
    QAction* viewReferenceFrameSettingsAction;
    QAction* recordCapture_Current_Frame_to_FileAction;
    QAction* recordCapture_Frames_to_FileAction;
    QAction* recordDump_to_Pcap_FileAction;
    QAction* Action;
    QAction* helpHelpAction;

public slots:
    virtual void timeSliderScaleRealeased();
    virtual void fileOpen();
    virtual void playPauseToolButtonClicked();
    virtual void pauseMenuAction();
    virtual void playMenuAction();
    virtual void replayFileModeSelected();
    virtual void monitorLocalHostSelected();
    virtual void viewVisDisplayPanel();
    virtual void playing();
    virtual void paused();
    virtual void timeScaleLineEditChanged();
    virtual void statusBarMessage( QString message );
    virtual void updateReplayRate( double value );
    virtual void timeScaleSliderChanged( int value );
    virtual void setNormalReplaySpeed();
    virtual void updateReplayTimeDisplay( const QDateTime & repPos, const QDateTime & timeWinEnd );
    virtual void updateReplayTimeSliderPosition( const QDateTime & repPos );
    virtual void replayPositionDateTimeChanged();
    virtual void replayPositionSliderChanged( int val );
    virtual void replayPoistionSliderReleased();
    virtual void applyReplayPosition();
    virtual void setTimeRange( const QDateTime start, const QDateTime end );
    virtual void updateTimeWindowDisplay( double seconds );
    virtual void timeWindowChange();
    virtual void updateTimeWindowSlider( double sec );
    virtual void timeWindowSliderChanged( int val );
    virtual void applyTimeWindow();
    virtual void timeWindowSliderReleased();
    virtual void applyFilter();
    virtual void viewPlotterSettings();
    virtual void viewReferenceFrameSettings();
    virtual void captureFramesToFile( bool activate );
    virtual void takeSnapshot();
    virtual void record( bool buttonOn );
    virtual void setRecordButton( bool buttonOn );
    virtual void reportErrorMessage( QString errMsg );
    virtual void showOnTop();
    virtual void helpDoc();
    virtual void helpAbout();

signals:
    void play();
    void pause();
    void showVisDisplayPanel();
    void togglePlayPause();
    void setReplayRate(double rate);
    void setReplayPosition(const QDateTime newRepPos);
    void setTimeWindow(double seconds);
    void selectReplayFile(const QString file);
    void setFilter(const QString filterExpr);
    void setHomeNetwork(int a, int b, int c, int d, int slash);
    void showHomeNetworkDialog();
    void selectNetworkInterface(const QString);
    void showPlotterSettings();
    void showReferenceFrameSettings();
    void captureFrames(bool);
    void captureSingleFrame();
    void recordToFile(bool);

protected:
    QVBoxLayout* ControlPanelLayout;
    QHBoxLayout* replayPositionGroupBoxLayout;
    QHBoxLayout* layout12;
    QHBoxLayout* ReplaySpeedGroupBoxLayout;
    QHBoxLayout* recordGroupBoxLayout;
    QHBoxLayout* HistoricViewGroupBoxLayout;
    QHBoxLayout* FilterGroupBoxLayout;

protected slots:
    virtual void languageChange();

private:
    double startTime;
    bool timeWinSetByUser;
    bool replayPosSetByUser;
    float timeScale;
    QIconSet *playIcon;
    QIconSet *pauseIcon;
    QLabel *packetEventsLabel;
    QDoubleValidator *timeScaleValidator;
    double timeSpan;
    bool replayPosSetBySlider;
    bool timeWindowSetBySlider;
    bool replayPositionSliderChangeStarted;
    bool recordToPcapFileSetByUser;
    bool captureFramesSetByUser;
    QErrorMessage *qErrMsg;
    AboutDialog *aboutDialog;
    HelpDocumentationDialog *helpDialog;
    QString loguiFileName;

    void init();
    void destroy();
    QString strGetRepPos();

};

#endif // CONTROLPANEL_H
